from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import Select
from wasabi import msg
import time

# 购票链接
ticket_url = 'https://www.s2.e-get.jp/lrpnot/pt/&lg=-1&s=I6332J'

round_idx = 1
cast_name = '小日向'
ticket_num = 1
wait_time = 1

# 构成log输出信息
msg_head = f'[{round_idx}] {cast_name}×{ticket_num}'
msg.info(f'{msg_head} - 开始抢票')
# 初始化浏览器
options = webdriver.ChromeOptions()
# 禁用插件
options.add_argument('--disable-extensions')
# 默认执行完不关闭窗口
options.add_experimental_option('detach', True)
driver = webdriver.Chrome(options=options)
retry_times = 0
# 开始抢票
while True:
    # 进入购票界面
    driver.get(ticket_url)
    # 处理服务器忙
    while True:
        if '/pt/' not in driver.current_url:
            msg.warn(f'{msg_head} - 服务器忙，准备重试')
            time.sleep(1)
            driver.get(ticket_url)
        else:
            break
    # 进入场次选择页面
    driver.find_element(By.CSS_SELECTOR, 'a.btn_reserve').click()
    # 选择场次
    rounds = driver.find_elements(By.CSS_SELECTOR, 'table#seat_condition tbody tr')
    target_row = rounds[round_idx + 1]
    # 检查余票情况
    s_ticket = target_row.find_elements(By.CSS_SELECTOR, 'td')[1]
    if s_ticket.text == '×':
        retry_times += 1
        msg.warn(f'{msg_head} - S席无余票，准备重试（{retry_times}）')
        time.sleep(wait_time)
        continue
    else:
        s_ticket.find_element(By.CSS_SELECTOR, 'a.conditon').click()
    # 选择特典cast
    casts = driver.find_elements(By.CSS_SELECTOR, 'table.reserve_number tbody tr')
    for cast in casts:
        if cast_name in cast.text:
            select = Select(cast.find_element(By.CSS_SELECTOR, 'select.number'))
            select.select_by_value(str(ticket_num))
            break
    # 提交，进入支付流程
    driver.find_element(By.CSS_SELECTOR, 'a.footer_next').click()
    # 判断提交结果
    if '/pt/cart.act' in driver.current_url:
        msg.good(f'{msg_head} - 抢票成功，待支付')
        # 修改窗口标题，便于管理
        driver.execute_script(f"document.title = '{msg_head}'")
        break
    else:
        msg.fail(f'{msg_head} - 抢票失败，准备重试')
        driver.quit()
